<?php
/* -----------------------------------------------------------------------------
  class name: common_plugin
  class version: 1.0
  date: 2007-10-31
  ------------------------------------------------------------------------------
  author: grum at grum.dnsalias.com
  << May the Little SpaceFrog be with you >>
  ------------------------------------------------------------------------------
  
  this class provides base functions to manage a plugin
    CONFIG RELATED
    - init_config()
    - load_config()
    - save_config()
    - delete_config()
    INITIALIZATION RELATED
    - set_tables_list($list)
    ADMINISTRATION RELATED
    - plugin_admin_menu($menu)
    - display_admin_page()
  ------------------------------------------------------------------------------
  HISTORY
  --------------------------------------------------------------------------- */

class common_plugin
{
  var $prefixeTable;  // prefixe for tables names
  var $plugin_name;   // plugin name 
  var $my_config;     // array of config parameters
  var $tables;   // list of all tables names used by plugin
  var $page_link; //link to admin page
  var $filelocation; //files plugin location on server
  var $display_result_ok;
  var $display_result_ko;

  /* constructor allows to initialize $prefixeTable value */
  function common_plugin($prefixeTable, $filelocation)
  {
    $this->filelocation=$filelocation;
    $this->prefixeTable=$prefixeTable;
    $this->page_link="admin.php?page=plugin&section=".
                        basename(dirname($this->filelocation))."/admin/plugin_admin.php";
    $this->init_config();
    $this->display_result_ok="OK";
    $this->display_result_ko="KO";
  }

  /* ---------------------------------------------------------------------------
     CONFIGURATION RELATED FUNCTIONS 
  --------------------------------------------------------------------------- */

  /* this function initialize var $my_config with default values */
  function init_config()
  {
    $this->my_config=array();
  }

  /* load config from CONFIG_TABLE into var $my_config */
  function load_config()
  {
    $this->init_config();
    $sql="SELECT value FROM ".CONFIG_TABLE."
          WHERE param = '".$this->plugin_name."_config'";
    $result=pwg_query($sql);
    if($result)
    {
      $row=mysql_fetch_row($result);
      if(is_string($row[0])) 
      {
        $config = unserialize($row[0]);
        reset($config);
        while (list($key, $val) = each($config)) 
        { $this->my_config[$key] =$val; }
      }
    }
  }

  /* save var $my_config into CONFIG_TABLE */
  function save_config()
  {
    $sql="REPLACE INTO ".CONFIG_TABLE." 
           VALUES('".$this->plugin_name."_config', '"
           .serialize($this->my_config)."', '')"; 
    $result=pwg_query($sql);
    if($result) 
    { return true; } 
    else 
    { return false; }
  }

  /* delete config from CONFIG_TABLE */
  function delete_config()
  {
    $sql="DELETE FROM ".CONFIG_TABLE." 
          WHERE param='".$this->plugin_name."_config'"; 
    $result=pwg_query($sql);
    if($result) 
    { return true; } 
    else 
    { return false; }
  }

  /* ---------------------------------------------------------------------------
     PLUGIN INITIALIZATION RELATED FUNCTIONS
  --------------------------------------------------------------------------- */

  /*
      initialize tables list used by the plugin
        $list = array('table1', 'table2')
        $this->tables_list['table1'] = $prefixeTable.$plugin_name.'_table1'
  */
  function set_tables_list($list)
  {
    for($i=0;$i<count($list);$i++)
    {
      $this->tables[$list[$i]]=$this->prefixeTable.$this->plugin_name.'_'.$list[$i];
    }
  }

  /* ---------------------------------------------------------------------------
     ADMINISTRATOR CONSOLE RELATED FUNCTIONS 
  --------------------------------------------------------------------------- */

  /* add plugin into administration menu */
  function plugin_admin_menu($menu)
  {
    array_push($menu,
               array(
                  'NAME' => $this->plugin_name,
                  'URL' => get_admin_plugin_menu_link(dirname($this->filelocation).
                                '/admin/plugin_admin.php')
                   ));
    return $menu;
  }

  /*
     display administration page
  */
  function display_admin_page()
  {
     
  }

  function debug($text)
  {
    global $page;
    array_push($page['infos'], "DEBUG MODE: ".$text);
  }

  /*
    manage infos & errors display
  */
  function display_result($action_msg, $result)
  {
    global $page;

    if($result)
    {
      array_push($page['infos'], $action_msg);
      array_push($page['infos'], $this->display_result_ok);
    }
    else
    {
      array_push($page['errors'], $action_msg);
      array_push($page['errors'], $this->display_result_ko);
    }
  }
} //class common_plugin

?>
